/********************************************************/
/*                     test.cpp                         */
/********************************************************/
/* Affiche a l'ecran un cube en 3D                      */
/********************************************************/

//le code OpenGL provient de LinuxGraphics : http://www.linuxgraphic.org/section3d/openGL/didacticiels/didac2/didac8.html
//Ceci en est une adaptation pour adviOGL car l'original utilise Glut.

/* inclusion du fichiers d'en-tete adviOGL */

#include <adviOGL.h>


/* Notre structure point */

typedef struct
{
  float x;
  float y;
  float z;
  float r;
  float g;
  float b;
} point;

point p[8]={
    {-0.5,-0.5, 0.5,1.0,0.0,0.0},
    {-0.5, 0.5, 0.5,0.0,1.0,0.0},
    { 0.5, 0.5, 0.5,0.0,0.0,1.0},
    { 0.5,-0.5, 0.5,1.0,1.0,1.0},
    {-0.5,-0.5,-0.5,1.0,0.0,0.0},
    {-0.5, 0.5,-0.5,0.0,1.0,0.0},
    { 0.5, 0.5,-0.5,0.0,0.0,1.0},
    { 0.5,-0.5,-0.5,1.0,1.0,1.0}};
  
int f[6][4]={
  {0,1,2,3},
  {3,2,6,7},
  {4,5,6,7},
  {0,1,5,4},
  {1,5,6,2},
  {0,4,7,3}};

char presse;
int anglex,angley,xold,yold;

/* Prototype des fonctions */
void affichage();
void clavier(event_keyboard,void*);
void mouse(event_mouse,void*);
void init();

int main()
{
  /* initialisation de ogl_support et creation
     de la fenetre */
  HideConsole();
  advInit(400,400,init);
  advGetOGL().SetCaption("cube");

  /* enregistrement des fonctions de rappel */
  advGetOGL().SetKeyboardCallBack(clavier);
  advGetOGL().SetMouseCallBack(mouse);
  advSetDrawCallBack(affichage);

  

  advWaitEnd();
  return 0;
}

/* Initialisation d'OpenGL */
void init()
{
  glClearColor(0.0,0.0,0.0,0.0);
  glColor3f(1.0,1.0,1.0);
  glPointSize(2.0);
  glEnable(GL_DEPTH_TEST);
}


void affichage()
{
  int i,j;
  /* effacement de l'image avec la couleur de fond */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glLoadIdentity();
  glRotatef(-angley,1.0,0.0,0.0);
  glRotatef(-anglex,0.0,1.0,0.0);
  /* Dessin du cube */
  glBegin(GL_QUADS);
  for (i=0;i<6;i++)
    {

      for (j=0;j<4;j++)
	    {
	      glColor3f(p[f[i][j]].r,p[f[i][j]].g,p[f[i][j]].b);
	      glVertex3f(p[f[i][j]].x,p[f[i][j]].y,p[f[i][j]].z);
	    }
      
    }
  glEnd();
  glFlush();
  advSwapBuffers();
}

void clavier(event_keyboard ev,void* data)
{
  GLenum a;
  switch (ev.keycode)
    {
    case 'p': /* affichage du carre plein */
      glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
      break;
    case 'f': /* affichage en mode fil de fer */
      glGetError();
      glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); 
      a=glGetError();
      break;
    case 's' : /* Affichage en mode sommets seuls */
      glPolygonMode(GL_FRONT_AND_BACK,GL_POINT);
      break;
    case 'd':
      glEnable(GL_DEPTH_TEST);
      break;
    case 'D':
      glDisable(GL_DEPTH_TEST);
      break;
    case 'q' : /*la touche 'q' permet de quitter le programme */
      exit(0);
    }
}


void mouse(event_mouse ev,void* data)
{
  /* si on appuie sur le bouton gauche */
  if (ev.button==LEFT && ev.action==DOWN) 
  {
    presse = 1; /* le booleen presse passe a 1 (vrai) */
    xold = ev.x; /* on sauvegarde la position de la souris */
    yold=ev.y;
  }
  /* si on relache le bouton gauche */
  if (ev.button==LEFT && ev.action==UP) 
    presse=0; /* le booleen presse passe a 0 (faux) */

  if (presse) /* si le bouton gauche est presse */
    {
      /* on modifie les angles de rotation de l'objet
	 en fonction de la position actuelle de la souris et de la derniere
	 position sauvegardee */
      anglex=anglex-(xold-ev.x); 
      angley=angley-(yold-ev.y);
    }
    
    xold=ev.x; /* sauvegarde des valeurs courante de le position de la souris */
    yold=ev.y;
  }